Index: formats/format_g729.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_g729.c,v
retrieving revision 1.9
diff -u -r1.9 format_g729.c
--- formats/format_g729.c	28 Jan 2004 21:32:48 -0000	1.9
+++ formats/format_g729.c	5 Apr 2004 20:00:59 -0000
@@ -183,8 +183,9 @@
 		offset = max - bytes;
 	if (whence != SEEK_FORCECUR) {
 		offset = (offset > max)?max:offset;
-		offset = (offset < min)?min:offset;
 	}
+	// protect against seeking beyond begining.
+	offset = (offset < min)?min:offset;
 	if (lseek(fs->fd, offset, SEEK_SET) < 0)
 		return -1;
 	return 0;
Index: formats/format_gsm.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_gsm.c,v
retrieving revision 1.14
diff -u -r1.14 format_gsm.c
--- formats/format_gsm.c	3 Feb 2004 16:57:00 -0000	1.14
+++ formats/format_gsm.c	5 Apr 2004 20:00:59 -0000
@@ -197,9 +197,10 @@
 		offset = distance + cur;
 	else if(whence == SEEK_END)
 		offset = max - distance;
+	// Always protect against seeking past the begining.
+	offset = (offset < min)?min:offset;
 	if (whence != SEEK_FORCECUR) {
 		offset = (offset > max)?max:offset;
-		offset = (offset < min)?min:offset;
 	} else if (offset > max) {
 		int i;
 		lseek(fs->fd, 0, SEEK_END);
Index: formats/format_pcm.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_pcm.c,v
retrieving revision 1.10
diff -u -r1.10 format_pcm.c
--- formats/format_pcm.c	8 Sep 2003 16:48:07 -0000	1.10
+++ formats/format_pcm.c	5 Apr 2004 20:01:00 -0000
@@ -172,8 +172,9 @@
 		offset = max - sample_offset;
 	if (whence != SEEK_FORCECUR) {
 		offset = (offset > max)?max:offset;
-		offset = (offset < min)?min:offset;
 	}
+	// always protect against seeking past begining.
+	offset = (offset < min)?min:offset;
 	return lseek(fs->fd, offset, SEEK_SET);
 }
 
Index: formats/format_pcm_alaw.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_pcm_alaw.c,v
retrieving revision 1.9
diff -u -r1.9 format_pcm_alaw.c
--- formats/format_pcm_alaw.c	28 Jan 2004 21:06:03 -0000	1.9
+++ formats/format_pcm_alaw.c	5 Apr 2004 20:01:00 -0000
@@ -253,8 +253,9 @@
 		offset = max - sample_offset;
 	if (whence != SEEK_FORCECUR) {
 		offset = (offset > max)?max:offset;
-		offset = (offset < min)?min:offset;
 	}
+	// Always protect against seeking past begining
+	offset = (offset < min)?min:offset;
 	return lseek(fs->fd, offset, SEEK_SET);
 }
 
Index: formats/format_wav.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_wav.c,v
retrieving revision 1.15
diff -u -r1.15 format_wav.c
--- formats/format_wav.c	2 Feb 2004 06:34:27 -0000	1.15
+++ formats/format_wav.c	5 Apr 2004 20:01:00 -0000
@@ -525,8 +525,9 @@
 		offset = max - samples;
         if (whence != SEEK_FORCECUR) {
 		offset = (offset > max)?max:offset;
-		offset = (offset < min)?min:offset;
 	}
+	// always protect the header space.
+	offset = (offset < min)?min:offset;
 	return lseek(fs->fd,offset,SEEK_SET);
 }
 
Index: formats/format_wav_gsm.c
===================================================================
RCS file: /usr/cvsroot/asterisk/formats/format_wav_gsm.c,v
retrieving revision 1.18
diff -u -r1.18 format_wav_gsm.c
--- formats/format_wav_gsm.c	26 Feb 2004 06:46:01 -0000	1.18
+++ formats/format_wav_gsm.c	5 Apr 2004 20:01:01 -0000
@@ -493,8 +493,9 @@
 		offset = distance + cur;
 	else if(whence == SEEK_END)
 		offset = max - distance;
+	// always protect against seeking past end of header
+	offset = (offset < min)?min:offset;
 	if (whence != SEEK_FORCECUR) {
-		offset = (offset < min)?min:offset;
 		offset = (offset > max)?max:offset;
 	} else if (offset > max) {
 		int i;
